#include "PowerDown.h"
UINT32              evcode_base;

UINT16 timeWait;
UINT16 timeWaitT;

UINT8 hourN1;
UINT8 minuteN1;

UINT32 eventCodeN1;
UINT32 eventCodeN2;

char nameCfgFile[64];

INT8 T; //   

int i;

BOOL exitN1;
BOOL exitN2;
BOOL exitN3;

UINT8 keyexitN1;
UINT8 keyexitN2;
UINT8 keyexitN3;

UINT8 hour,minute;

UINT8 ccc[3];

UINT8* p2; 

/*  .        */
const char app_name[APP_NAME_LEN] = "PowerDown"; 


//     state-

/*    HW_STATE_ANY (   state) */
const EVENT_HANDLER_ENTRY_T any_state_handlers[] =
{


    //      
    { STATE_HANDLERS_END,           NULL           },
};

const EVENT_HANDLER_ENTRY_T main_state_handlers[] =
{
	{ EV_KEY_PRESS,             HandleKeypress },
	{ EV_KEY_RELEASE,         HandleKeyrelease },
	{ EV_TIMER_EXPIRED,       		     Timer },
    { STATE_HANDLERS_END,           NULL           },
};

/*   ,    -  .
      ,   enum-e */
static const STATE_HANDLERS_ENTRY_T state_handling_table[] =
{
    { HW_STATE_ANY,               // State
      NULL,                       //    state
      NULL,                       //    state
      any_state_handlers          //   
    },

    { HW_STATE_MAIN,
      MainStateEnter,
      NULL,
      main_state_handlers
    }

};


/*  entry   ,      */
/* file_uri -    ( argv[0]) */
/* param -   (  argv) */
/* reserve -   eventcode- ( 64 )*/
UINT32 Register( char* file_uri,  char* param,  UINT32 reserve )
{
    UINT32 status = RESULT_OK;
    evcode_base = reserve;    //  reserve



/*   */
    status = APP_Register( &evcode_base,            //      
                           1,                       // - ,     
                           state_handling_table,    //  
                           HW_STATE_MAX,            //  
                           (void*)startApp );   // ,   



		for (i=0; i < strlen(file_uri)-3; i++)
		{
			nameCfgFile[i] = file_uri[i];
		}

		strcat(nameCfgFile, "cfg");

    LdrStartApp(reserve);   //  

    return 1;   //    ,  
}


/*      */
UINT32 startApp( EVENT_STACK_T *ev_st,  REG_ID_T reg_id,  UINT32 param2 )//void *reg_hdl
{
    APP_POWERDOWN_T     *app = NULL;
    UINT32 status = RESULT_OK;

	WCHAR buf[64];
	UINT8 bufR[14];
	UINT32 readen;
	FILE_HANDLE_T f;



    /* ,    ? */
    if( AFW_InquireRoutingStackByRegId( reg_id ) == RESULT_OK )
    {
        return RESULT_FAIL; //     
    }
    else
    {
        //    
        app = (APP_POWERDOWN_T*)APP_InitAppData( (void *)APP_HandleEventPrepost, //    
                                                  sizeof(APP_POWERDOWN_T), //   
                                                  reg_id,
                                                  0, 1,
                                                  1,
                                                  2, 0, 0 );


        status = APP_Start( ev_st,
                            &app->apt,
                            HW_STATE_MAIN, //  
                            state_handling_table,
                            destroyApp,
                            app_name,
                            0 );



		if (DL_FsFFileExist( u_atou(nameCfgFile, buf)) == TRUE ) //    
		{
			f = DL_FsOpenFile(u_atou(nameCfgFile, buf), FILE_READ_MODE, 0);
			DL_FsReadFile( bufR, 14, 1, f, &readen );
			DL_FsCloseFile(f);

				hourN1 = bufR[0];
				minuteN1 = bufR[1];

				timeWait = bufR[3];

        eventCodeN1 = bufR[5]*0x100 +  bufR[6];
        eventCodeN2 = bufR[8]*0x100 +  bufR[9];

				keyexitN1 = bufR[11];
				keyexitN2 = bufR[12];
				keyexitN3 = bufR[13];
		}

		if (timeWait != 0) 
		{
			APP_UtilStartCyclicalTimer( 1000,  1,  app );
			T = 1;
		}	
		

    }

    return RESULT_OK;
}


/*     */
UINT32 destroyApp( EVENT_STACK_T *ev_st,  void *app )
{
    UINT32  status;

	APP_UtilStopTimer( app );
    /*    */
    status = APP_Exit( ev_st, app, NULL );



    /*   */
    LdrUnloadELF(&Lib); // &Lib    

    return status;
}

/*    state */
UINT32 MainStateEnter( EVENT_STACK_T *ev_st,  void *app,  ENTER_STATE_TYPE_T type )
{
    return RESULT_OK;
}


/*  , EV_KEY_PRESS    */
UINT32 HandleKeypress( EVENT_STACK_T *ev_st,  void *app )
{
    EVENT_T     *event = AFW_GetEv(ev_st);
	  UINT8       keypress;


	keypress = event->data.key_pressed;


		if (timeWait != 0 && T != 1)	
		{
			APP_UtilStopTimer( app );
			APP_UtilStartCyclicalTimer( 1000,  1,  app );
			T = 1;
		}

    if(keypress == keyexitN1) 
    {
    	exitN1=TRUE;
    }
   
    if(keypress == keyexitN2 && exitN1==TRUE)
    {	
    	exitN2=TRUE;
    }
   
    if(keypress == keyexitN3 && exitN1==TRUE && exitN2==TRUE) 
    {
    	exitN3=TRUE;
			HAPI_LP393X_set_tri_color_led( 0,  0x00F );
			for (i=0; i < 10000; i++ ) {}
			HAPI_LP393X_set_tri_color_led( 0,  0x000 );
     	return destroyApp(ev_st, app);
    }

		if (keypress != keyexitN1 && keypress != keyexitN2 && keypress != keyexitN3 )
		{
			exitN1 = FALSE;
			exitN2 = FALSE;
			exitN3 = FALSE;
		}

	timeWaitT=0;


    return RESULT_OK;
}


UINT32 HandleKeyrelease( EVENT_STACK_T *ev_st,  void *app )
{
	timeWaitT=0;
	
	return RESULT_OK;
}

UINT32 Timer( EVENT_STACK_T *ev_st,  void *app )
{
	
	if (((DL_TIMER_DATA_T*)(AFW_GetEv(ev_st)->attachment))->ID == 1)
	{
		timeWaitT ++;

		if (timeWaitT >= timeWait) 
		{
			HAPI_LP393X_set_tri_color_led( 0,  0x00F );
			for (i=0; i < 10000; i++ ) {}
			HAPI_LP393X_set_tri_color_led( 0,  0x000 );
			T = 0;
			Comparetime();
		}	
	}

	return RESULT_OK;
}

UINT32 Comparetime()
{
    p2=&ccc[0];
      
    DL_ClkGetTime(p2);
       
    hour=ccc[0];
    minute=ccc[1];
    
    if (hour >= hourN1 && minute >= minuteN1)
    {
		AFW_CreateInternalQueuedEvAux( eventCodeN1, 0x64, 0, 0 );
		AFW_CreateInternalQueuedEvAux( eventCodeN2, 0x64, 0, 0 );
    }

   return RESULT_OK;
}
